function engine = mk_complex_dbn(nNodes, nDisplays, prior, obsmat, transmat)

%Define network structure 
%-------------------------
intra = zeros(nNodes);
intra(1,[2: nNodes]) = 1;
inter = zeros(nNodes);
inter(1,1) = 1;
%inter(2,2)=0;
%inter(3,3)=0;

node_sizes = 2*ones(1,nNodes); 

dnodes = 1:nNodes;    
onodes = 2:nNodes;  %observed node
eclass1 = 1:nNodes;
eclass2 = [nNodes+1 2:nNodes]; 
bnet = mk_dbn(intra, inter, node_sizes, 'discrete', dnodes, 'eclass1', eclass1, 'eclass2', eclass2, ...
	      'observed', onodes);

bnet.CPD{1} = tabular_CPD(bnet, 1, 'CPT', prior);
for i=1:nDisplays
    bnet.CPD{i+1} = tabular_CPD(bnet, i+1, 'CPT', obsmat{i});
end
bnet.CPD{nNodes+1} = tabular_CPD(bnet, nNodes+1, 'CPT', transmat);

%Create Inference engine
engine = jtree_dbn_inf_engine(bnet);
